type Pizza = {
    name: string;
    // TODO ingredience
    sizes: [
        size: number,
        price: number,
    ];
}

const getBaseUrl = (): string => {
    if (process.env.PUBLIC_URL) {
        return process.env.PUBLIC_URL;
    }
    return 'http://localhost:3001';
}

async function request<TResponse>(
    url: string,
    config: RequestInit = {}
): Promise<TResponse> {
    console.log("Calling fetch on", getBaseUrl() + url);
    return fetch(getBaseUrl() + url, config).then(response => {
        if (!response.ok) {
            console.log("Response", response.status)
            throw new Error(response.statusText);
        }
        console.log("response", response);
        return response.json() as TResponse;
    });
}

const api = {
    get: <TResponse>(url: string) => request<TResponse>(url),
    post: <TBody extends BodyInit, TResponse>(url: string, body: TBody) => request<TResponse>(url, { method: 'POST', body }),
}

export const getPizzy = async () => {
    return await api.get<any>('/api/pizza');
}